﻿'© By Andrea Bruno
'Open source, but: This source code (or part of this code) is not usable in other applications

Namespace WebApplication
	Public Module Ftp
		Private Class InetEmulator
			Sub Cancel()
			End Sub
			Public Protocol As Integer
			Public RemotePort As Integer
			Public RequestTimeout As Integer
			Public URL As String
			Public UserName As String
			Public Password As String
			Public AccessType As Integer
			Public ReadOnly Property ResponseInfo()
				Get
					Return ""
				End Get
			End Property
			Public ReadOnly Property stillexecuting() As Boolean
				Get
					Return m_stillexecuting
				End Get
			End Property
			Private m_stillexecuting As Boolean
			Public Sub Execute(ByVal URL As String, ByVal Command As String)
				'Inet.Execute(Inet.URL, "delete " & NewName)
				'Inet.Execute(Inet.URL, "put " & File & " " & NewName)
				'-uftp://ftp.xoom.it/x.txt -mput -fx.txt -kukocahoctpa:xxxx
				If Left(URL.ToLower, 6) <> "ftp://" Then
					URL = "ftp://" & URL
				End If
				URL = ExtrapolatePath(URL)
				m_stillexecuting = True
				Dim Parameters As String
				Parameters = "-ku" & UserName & ":" & Password & " "
				Dim w() As String = Split(Command)
				Select Case w(0).ToLower
					Case "dir"
						Parameters = Parameters & "-m" & w(0) & " "
					Case "put"
						Parameters = Parameters & "-m" & w(0) & " "
						If w.Length >= 2 Then
							Parameters = Parameters & "-f" & w(1) & " "
						End If
					Case "get"
						Parameters = Parameters & "-m" & w(0) & " "
						If w.Length >= 2 Then
							Parameters = Parameters & "-f" & w(1) & " "
						End If
					Case "delete"
						'DEL not supported!
						m_stillexecuting = False
						Exit Sub
				End Select
				Parameters = Parameters & "-u" & URL
				Select Case w(0).ToLower
					Case "put", "get"
						If w.Length >= 3 Then
							Dim Remote As String
							Remote = Replace(w(2), "\", "/")
							If (Left(Remote, 1) <> "/") And Right(URL, 1) <> "/" Then
								Remote = "/" & Remote
							End If
							Parameters = Parameters & Remote
						End If
				End Select


				'THIS PART IS REBOVED
				'EntryPoint.Main(Split(Parameters))



				m_stillexecuting = False
			End Sub
			Private Function ExtrapolatePath(ByVal Url As String) As String
				If Right(Url, 1) <> "/" Then
					Url = Url & "/"
				End If
				Dim p As Integer
				For n As Integer = 1 To 3
					p = InStr(p + 1, Url, "/")
				Next
				If p Then
					Return Left(Url, p)
				End If
			End Function
		End Class

		Public Class Executor
			Public Sub New()
				Try
					'Inet As InetCtlsObjects.Inet = New InetCtlsObjects.Inet			'REFERENCE: %SystemRoot%\system32\msinet.ocx			
					'Inet = New InetCtlsObjects.Inet			 'REFERENCE: %SystemRoot%\system32\msinet.ocx			
					Inet = CreateObject("InetCtls.Inet")
				Catch ex As Exception
					Inet = New Ftp.InetEmulator
				End Try
			End Sub

			'Private Inet As InetCtlsObjects.Inet = New InetCtlsObjects.Inet			'REFERENCE: %SystemRoot%\system32\msinet.ocx			
			Private Inet	 'As InetCtlsObjects.Inet

			'Command
			'Sintax
			'________________________________________________ 
			'CD newdir
			' Changes directory (e.g., Execute , "CD gifs\thegifs").
			'________________________________________________ 
			'CDUP
			' Changes to parent directory. Identical to "CD ..".
			'________________________________________________ 
			'DELETE file
			' Deletes specified file (e.g., Execute , "DELETE nogood.dat").
			'________________________________________________  
			'DIR [newdir]
			' Searches current directory or directory specified. Use GetChunk() to get the data (e.g., Execute , "DIR /gifs").
			' ________________________________________________ 
			'GET source target
			' Gets file "source" and creates a local file "target" (e.g., Execute , "GET source.txt C:\target.txt").
			' ________________________________________________ 
			'LS
			' List. Same as DIR.
			' ________________________________________________ 
			'MKDIR newdir
			' Creates new directory newdir (e.g., Execute , "MKDIR /newdir").
			' ________________________________________________ 
			'PUT source target
			' Copies local file "source" to remote computer as "target" (e.g., Execute , "PUT C:\source.txt target.txt").
			'________________________________________________  
			'PWD
			' Print Working Directory. Use GetChunk() method to get the data (e.g., Execute , "PWD").
			'________________________________________________ 
			'
			'QUIT
			' Close the connection (e.g., Execute , "QUIT").
			'________________________________________________  
			'RECV source target
			' Same as GET.
			'________________________________________________  
			'RENAME oldname 
			' Renames a file (e.g., Execute , "RENAME oldnewname name.txt newname.txt").
			' ________________________________________________ 
			'RMDIR dirname
			' Removes directory (e.g., Execute , "RMDIR dirname").
			' ________________________________________________ 
			'SEND source
			' Same as PUT.
			' ________________________________________________ 
			'SIZE filename
			' Gets the size of specified file (e.g., Execute "SIZE filename.txt").
			'________________________________________________ 

			Sub Open(ByRef FtpServer As String, ByRef UserName As String, ByRef Password As String)
				Inet.cancel()
				Inet.Protocol = 2
				Inet.RemotePort = 21
				Inet.RequestTimeout = 10
				Inet.URL = FtpServer		'URL should be set first
				Inet.UserName = UserName
				Inet.Password = Password		'password here
			End Sub
			Function PutFile(ByVal File As String, Optional ByRef NewName As String = Nothing, Optional ByRef WaitEndOfProcess As Boolean = True) As Boolean
				If InStr(File, ":", CompareMethod.Binary) = 0 Then
					File = MapPath(File)
				End If
				If NewName = "" Then
					Dim x As String
					x = Replace(File, "\", "/")
					Dim a = Split(x, "/")
					NewName = a(UBound(a))
				End If

				NewName = FtpPath(Inet.URL) & NewName
				Inet.AccessType = 1
				'Inet.Execute(Inet.URL, "delete " & NewName)
				'NewName = "archive/" & NewName
				Try
					Inet.Execute(Inet.URL, "put " & File & " " & NewName)
					If WaitEndOfProcess Then
						While Inet.StillExecuting = -1
							System.Threading.Thread.Sleep(100)
							'System.Windows.Forms.Application.DoEvents()
						End While
					End If
					Return True
				Catch ex As Exception
					Return False
				End Try
				System.Diagnostics.Debug.Write(Inet.ResponseInfo)
			End Function
			Private Function FtpPath(ByVal Url As String) As String
				If Right(Url, 1) <> "/" Then
					Url = Url & "/"
				End If
				Dim p As Integer
				For n As Integer = 1 To 3
					p = InStr(p + 1, Url, "/")
				Next
				If p Then
					FtpPath = Mid(Url, p + 1)
				End If
			End Function
			Function GetFile(ByRef File As String, Optional ByRef NewName As String = Nothing, Optional ByRef WaitEndOfProcess As Boolean = True) As Boolean
				If NewName = "" Then
					NewName = MapPath(File)
				End If
				Inet.AccessType = 1
				Try
					Inet.Execute(Inet.URL, "get " & File & " " & NewName)
					If WaitEndOfProcess Then
						While Inet.StillExecuting = -1
							System.Threading.Thread.Sleep(100)
							'System.Windows.Forms.Application.DoEvents()
						End While
					End If
					Return True
				Catch ex As Exception
					Return False
				End Try
			End Function
			Function InProgress() As Boolean
				InProgress = Inet.StillExecuting
			End Function
			Function Delete(ByVal RemoteFile As String, Optional ByRef WaitEndOfProcess As Boolean = True) As Boolean
				Inet.AccessType = 1
				Try
					Inet.Execute(Inet.URL, "delete " & RemoteFile)
					If WaitEndOfProcess Then
						While Inet.StillExecuting = -1
							System.Threading.Thread.Sleep(100)
							'System.Windows.Forms.Application.DoEvents()
						End While
					End If
					Return True
				Catch ex As Exception
					Return False
				End Try
			End Function
		End Class

		Public Class FtpSpooler
			Private _IsInizialized As Boolean
			Public Function IsInizialized()
				IsInizialized = _IsInizialized
			End Function
			Private FtpExecutor As New Ftp.Executor
			Private Spooler As New Collection

			Public Sub Initialize(ByRef FtpServer, ByRef UserName, ByRef Password)
				FtpExecutor.Open(FtpServer, UserName, Password)
				_IsInizialized = True
			End Sub
			Public Sub AddToSpoler(ByVal Operation As Operation, ByRef File As String, Optional ByRef NewName As String = Nothing, Optional ByRef DeleteSource As Boolean = False)
				Dim s As New SpoolElement
				s.Operation = Operation
				s.File = File
				s.NewName = NewName
				s.DeleteSource = DeleteSource
				Spooler.Add(s)
			End Sub
			Class SpoolElement
				Public Operation As Operation
				Public File As String
				Public NewName As String
				Public DeleteSource As Boolean
			End Class
			Enum Operation As Integer
				PutFile = 0
				GetFile = 1
				DeleteFile = 2
			End Enum

			Public Function SpoolerCount() As Integer
				SpoolerCount = Spooler.Count
			End Function

			Private Sub TryNextOperation(ByVal sender As Object, ByVal ElapsedEventArgs As System.Timers.ElapsedEventArgs)
				Static flag As Boolean
				If flag = False Then
					flag = True
					If fl_InExecution Then
						If FtpExecutor.InProgress Then
							flag = False
							Exit Sub
						Else
							fl_InExecution = False
							Dim Spool As SpoolElement = Spooler(1)
							Spooler.Remove(1)
							If Spool.DeleteSource Then
								Select Case Spool.Operation
									Case Operation.PutFile
										FileManager.Delete(PathFile(Spool.File))
									Case Operation.GetFile
										FtpExecutor.Delete(Spool.File)
								End Select
							End If
						End If
					End If
					If Spooler.Count Then
						If fl_InExecution = False Then
							fl_InExecution = True
							Dim Spool As SpoolElement = Spooler(1)
							If _IsInizialized Then
								Select Case Spool.Operation
									Case Operation.GetFile
										FtpExecutor.GetFile(Spool.File, Spool.NewName, False)
									Case Operation.PutFile
										FtpExecutor.PutFile(Spool.File, Spool.NewName, False)
									Case Operation.DeleteFile
										FtpExecutor.Delete(Spool.File, False)
								End Select
							Else
								Err.Raise(10000, , "FtpSpooler not initializated!")
							End If
						End If
					End If
					flag = False
				End If
			End Sub

			Private fl_InExecution As Boolean

			Private Timer As New System.Timers.Timer

			Public Sub New()
				AddHandler Timer.Elapsed, AddressOf TryNextOperation
				Timer.Interval = 200
				Timer.Start()
			End Sub
		End Class
	End Module
End Namespace