' By Andrea Bruno
'Open source, but: This source code (or part of this code) is not usable in other applications
Imports Microsoft.VisualBasic
Namespace WebApplication
	Public Module Skype
		Function CurrentSkypecast(ByVal Setting As SubSite) As Skypecast
			Return GenericCurrentSkypecast
		End Function
		Public GenericCurrentSkypecast As Skypecast
		Public GenericSkypecastTitle As String = "  "
		Public Sub CheckSkypecast()
			Dim KeyWord As String = GenericSkypecastTitle
			Dim Feeds As New System.Collections.Generic.List(Of NewsManager.Notice)
			Dim Request As New NewsManager.NewsRequire
			Request.XmlHref = "http://feedsskypecasts.skype.com/skypecasts/webservice/feed.html?limit=1&search=" & System.Web.HttpUtility.UrlEncode(KeyWord)
			Try
				ReadFeed(Feeds, Request)
			Catch ex As Exception
				Exit Sub
			End Try
			Dim Skypecast As Skypecast
			For Each Feed As NewsManager.Notice In Feeds
				Skypecast = New Skypecast(Feed)
				If Skypecast.IsOnline Then
					Exit For
				End If
			Next

			If GenericCurrentSkypecast IsNot Nothing AndAlso GenericCurrentSkypecast.IsEnded Then
				'Remove ended skypecast
				GenericCurrentSkypecast = Nothing
			End If

			If GenericCurrentSkypecast Is Nothing Then
				'Add a new skypecast finded
				GenericCurrentSkypecast = Skypecast
			Else
				If Skypecast Is Nothing Then
					If Not GenericCurrentSkypecast.IsOnline Then
						'The skypecast is ended
						GenericCurrentSkypecast = Nothing
					End If
				ElseIf GenericCurrentSkypecast.ID <> Skypecast.ID Then
					If Skypecast.IsOnline Then
						'are start a new skypecast
						GenericCurrentSkypecast = Skypecast
					End If
				End If
			End If
		End Sub
		Class Skypecast
			Public Start As Date
			Public Title As String
			Public Description As String
			Public ID As Integer
			Function IdCall() As String
				'Static Acquiring As Boolean
				Static LastAcquiring As Date
				If IsOnline() And IDdetect = "" Then
					Dim Minutes As Integer = DateDiff(DateInterval.Minute, LastAcquiring, Now)
					If Minutes >= 5 Then
						LastAcquiring = Now
						Try
							Dim NewThread As System.Threading.Thread = New System.Threading.Thread(AddressOf AcquireIdCall)
							NewThread.Priority = Threading.ThreadPriority.Lowest
							NewThread.Start()
							'AcquireIdCall()
						Catch ex As Exception
						End Try
					End If

				End If
				Return IDdetect
			End Function
			Private IDdetect As String
			Public FailAcquire As Integer
			Private Sub AcquireIdCall()
				Static Acquiring As Boolean
				If Acquiring = False Then
					Acquiring = True
					Dim Url As String = "http://195.131.215.20/skype.aspx?title=" & System.Web.HttpUtility.UrlEncode(Me.Title)
					Try
						Dim Detect As String = ReadHtmlFromWeb(Url, System.Text.Encoding.GetEncoding("windows-1251"), 30000)
						If Detect <> "" Then
							IDdetect = Detect
						End If
					Catch ex As Exception
						FailAcquire += 1
					End Try
					Acquiring = False
				End If
			End Sub
			Private Sub AcquireIdCall2()
				'this routine not work correctly
				Dim Url As String = "https://skypecasts.skype.com/skypecasts/skypecast/search.html?search=" & System.Web.HttpUtility.UrlEncode(Me.Title) & "&setlang=it"
				Dim Html As String = ReadHtmlFromWeb(Url, System.Text.Encoding.GetEncoding("windows-1251"))
				Dim Position As Integer = InStr(Html, "joinCast('+")
				If Position Then
					Dim LenId As Integer = Position - InStr(Position, Html, "?") - 10
					IDdetect = Mid(Html, Position + 10, LenId)
				End If
			End Sub

			Function IsOnline() As Boolean
				Dim Minute As Integer = StartCountdownMinute()
				Return IsStarted() AndAlso Not IsEnded()
			End Function

			Function IsStarted() As Boolean
				Dim Minute As Integer = StartCountdownMinute()
				Return Minute < 0
			End Function

			Function IsEnded() As Boolean
				Dim Minute As Integer = StartCountdownMinute()
				Return Minute < -320
			End Function


			Function StartCountdownMinute() As Integer
				Return DateDiff(DateInterval.Minute, Now.ToUniversalTime, Start)
			End Function

			Public Sub New(ByVal Feed As NewsManager.Notice)
				'Me.Start = Feed.pubDate
				Me.Title = Feed.Title
				Dim Link As String = Feed.Link
				Dim Position As Integer = InStr(Link, "id_talk=")
				If Position Then
					ID = Val(Mid(Link, Position + 8))
				End If
				Me.Description = Feed.Description
				Position = InStr(Feed.Description, ">Starts on ")
				If Position Then
					Position += 11
					Dim EndPosition As Integer = InStr(Position, Feed.Description, "<")
					Dim StartTimeString As String = Mid(Feed.Description, Position, EndPosition - Position)
					'Try
					'Me.Start = System.DateTime.ParseExact(StartTimeString, "r", Culture)
					'Catch ex As Exception
					Dim Culture As Globalization.CultureInfo = New Globalization.CultureInfo("en-US")
					Me.Start = System.DateTime.ParseExact(StartTimeString, "ddd, d MMM yyyy HH':'mm':'ss 'GMT'", Culture)
					'End Try
				End If
			End Sub
			Function UrlConnect()
				If IDdetect IsNot Nothing Then
					Return SkypeUrl(IDdetect)
				End If
			End Function
			Function HiperLinkConnect()
				Dim Link As New HyperLink
				Link.NavigateUrl = UrlConnect()
				Link.Attributes.Add("rel", "nofollow")
				Return Link
			End Function

		End Class

		Public Function IsValidSkypeUserName(ByVal Text As String) As Boolean
			For Each Chr As Char In Text.ToCharArray
				If Not (Char.IsLetterOrDigit(Chr) Or Chr = "."c Or Chr = "_"c Or Chr = ","c Or Chr = "@"c Or Chr = "-"c) Then
					Return False
				End If
			Next
			Return True
		End Function

		Public Function SkypeHyperLink(ByVal SkypeUserName As String) As WebControls.HyperLink
			Dim HyperLink As New WebControls.HyperLink
			HyperLink.NavigateUrl = SkypeUrl(SkypeUserName)
			HyperLink.ImageUrl = "http://mystatus.skype.com/smallicon/" & ImgOnlineSkypeUser(SkypeUserName)
			HyperLink.Width = 16
			HyperLink.Height = 16
			HyperLink.ToolTip = "Skype"
			Return HyperLink
		End Function

		Private Function ImgOnlineSkypeUser(ByVal SkypeUserName As String) As String
			For Each Chr As Char In SkypeUserName.ToCharArray
				If Char.IsLetterOrDigit(Chr) Then
					ImgOnlineSkypeUser &= Chr
				Else
					ImgOnlineSkypeUser &= "-" & Right("00" & Hex(Asc(Chr)), 2)
				End If
			Next
		End Function

		Public Function SkypeUrl(ByVal SkypeUserName As String) As String
			If SkypeUserName <> "" Then
				If SkypeUserName.StartsWith("+") Then
					Return "skype:" & SkypeUserName & "?call"
				Else
					Return "skype:" & String2HexHtml(SkypeUserName) & "?call"
				End If
			End If
		End Function

	End Module
End Namespace

